#include <stdio.h>
#include <stdlib.h>

#define N 100

void stampa_matrice_st(int mat[][100], int m, int n) {
    int i, j;
    for (i = 0; i < m; i++) {
        for (j = 0; j < n; j++) {
            printf("%d ", mat[i][j]);
        }
        printf("\n");
    }
}

void stampa_matrice_din(int** mat, int m, int n) {
    int i, j;
    for (i = 0; i < m; i++) {
        for (j = 0; j < n; j++) {
            printf("%d ", mat[i][j]);
        }
        printf("\n");
    }
}

void init_rnd(int A[][100], int m, int n) {
    srand(time(0));
    int i, j;
    for (i = 0; i < m; i++) {
        for (j = 0; j < n; j++) {
            A[i][j] = rand() % 10;
        }
    }
}

void transponovanje1(int A[][100], int m, int n) {
    int i, j;
    for (i = 0; i < m; i++) {
        for (j = i+1; j < n; j++) {
            int tmp = A[i][j];
            A[i][j] = A[j][i];
            A[j][i] = tmp;
        }
    }
}

int** transponovanje2(int A[][100], int m, int n) {
    int i, j;
    int** B = malloc(n*sizeof(int*));
    for (i = 0; i < n; i++) {
        B[i] = malloc(m*sizeof(int));
    }
    for (i = 0; i < m; i++) {
        for (j = 0; j < n; j++) {
            B[j][i] = A[i][j];
        }
    }
    return B;
}

void mnozenje(int A[N][N], int B[N][N], int C[N][N], int m, int n, int p) {
    int i, j, k;
    for (i = 0; i < m; i++) {
        for (j = 0; j < p; j++) {
            int s = 0;
            for (k = 0; k < n; k++) {
                s = s + A[i][k] * B[k][j];
            }
            C[i][j] = s;
        }
    }
}

void flip_h(int A[N][N], int m, int n) {
    int i, j;
    for (i = 0; i < m/2; i++) {
        for (j = 0; j < n; j++) {
            int tmp = A[i][j];
            A[i][j] = A[m-1-i][j];
            A[m-1-i][j] = tmp;
        }
    }
}

void flip_v(int A[N][N], int m, int n) {
    int i, j;
    for (i = 0; i < m; i++) {
        for (j = 0; j < n/2; j++) {
            int tmp = A[i][j];
            A[i][j] = A[i][n-1-j];
            A[i][n-1-j] = tmp;
        }
    }
}

void rot90(int A[N][N], int B[N][N], int m, int n) {
    int i, j;
    for (i = 0; i < m; i++) {
        for (j = 0; j < n; j++) {
            B[j][m-1-i] = A[i][j];
        }
    }
}

void rot90_2(int A[N][N], int m, int n) {
    transponovanje1(A, m, n);
    flip_v(A, n, m);
}


/// za vjezbu:
/// trag, sabiranje, linearna kombinacija, inverzna
/// sortiranje vrsta/kolona
/// min/max vrsta/kolona

void spiralna(int A[N][N], int m, int n) {
    int i = 0;
    int j = 0;
    int smjer = 0;
    int br = 1;

    while (br <= m*n) {
        if (i >= 0 && i < m && j >= 0 && j < n && A[i][j] == 0) {
            A[i][j] = br;
            if (smjer == 0)
                j++;
            else if (smjer == 1)
                i++;
            else if (smjer == 2)
                j--;
            else
                i--;
            br++;
        }
        else {
            if (smjer == 0) {
                j--;
                i++;
                smjer = 1;
            }
            else if (smjer == 1) {
                i--;
                j--;
                smjer = 2;
            }
            else if (smjer == 2) {
                j++;
                i--;
                smjer = 3;
            }
            else {
                i++;
                j++;
                smjer = 0;
            }
        }
    }
}

int main()
{
    int A[100][100];
    int m = 3;
    int n = 5;
    init_rnd(A, m, n);
    stampa_matrice_st(A, m, n);
    printf("\n");
    int** mat = transponovanje2(A, m, n);
    stampa_matrice_din(mat, n, m);

    int B[N][N];
    int p = 4;
    init_rnd(B, n, p);
    printf("\n");
    stampa_matrice_st(B, n, p);
    printf("\n");

    int C[N][N];
    mnozenje(A, B, C, m, n, p);
    stampa_matrice_st(C, m, p);
    printf("\n");

    flip_h(B, n, p);
    stampa_matrice_st(B, n, p);
    printf("\n");
    flip_v(B, n, p);
    stampa_matrice_st(B, n, p);
    printf("\n");

    stampa_matrice_st(A, m, n);
    printf("\n");
    //transponovanje1(A, m, n);
    //flip_v(A, n, m);
    rot90_2(A, m, n);
    stampa_matrice_st(A, n, m);
    printf("\n");

    stampa_matrice_st(B, n, p);
    printf("\n");
    rot90(B, C, n, p);
    stampa_matrice_st(C, p, n);
    printf("\n");

    int S[N][N] = {0};
    spiralna(S, 4, 4);
    stampa_matrice_st(S, 4, 4);

    return 0;
}
